<?php
class Wics_Welpp_Helper_Data extends Mage_Core_Helper_Abstract {
    /**
     * Get the orders that were sent to Welpp
     *
     * @return Mage_Sales_Model_Resource_Order_Collection
     */
    public function getSentOrders()
    {
        // Get all orders that are processing
        $all_orders = Mage::getModel('sales/order')
                    ->getCollection()
                    ->addFieldToFilter('state', 'processing');   

        // Filter the orders that were never sent to Wics
        $sent_order_ids = array();
        foreach ($all_orders as &$order) 
        {
            $status_histories = Mage::getResourceModel('sales/order_status_history_collection')
                ->setOrderFilter($order)
                ->setOrder('created_at', 'desc')
                ->setOrder('entity_id', 'desc')
                ->addFieldToFilter('status', Wics_Welpp_Model_Observers_Order::WICS_ORDER_STATUS_CODE_OK); 

            // The order was sent to Welpp
            if (count($status_histories) > 0) 
            {
                $sent_order_ids[] = $order->getId();
            }
        }

        // Load the orders that were sent to Welpp
        $orders = Mage::getModel('sales/order')
                    ->getCollection()
                    ->addFieldToFilter('entity_id', array('in'=>$sent_order_ids));

        return $orders;
    }
}