<?php

class Wics_Welpp_Model_Cron 
{

    public function runOrders()
    {
        if (Mage::getStoreConfig('Wics_Welpp/order_status/enabled', Mage::app()->getStore()) === '1' || isset($_GET['notive_check'])) {
            $this->_checkOrderStatus();
        }
    }

    public function runStock()
    {
       if (Mage::getStoreConfig('Wics_Welpp/stock_sync/enabled', Mage::app()->getStore()) === '1' || isset($_GET['notive_check'])) {
            $this->_checkStock();
       }
    }
    
    public function runItemExport(){
//         if (Mage::getStoreConfig('Wics_Welpp/item_export/enabled', Mage::app()->getStore()) === '1' || isset($_GET['notive_check'])) {
//             Mage::log( 'runItemExport is enabled', null, 'wics.log' );
//             $this->_itemExport();
//         } else {
//             Mage::log( 'runItemExport is disabled', null, 'wics.log' );
//         }
    }

    private function _checkOrderStatus()
    {
        // Get the helpers
        $helper_webservice = Mage::getSingleton('Wics_Welpp_Helper_Webservice');
        $helper_data = Mage::getSingleton('Wics_Welpp_Helper_Data');
    
        Mage::log( 'Running checkOrderStatus...', null, 'wics.log' );
    
        // Load the orders
        $orders = $helper_data->getSentOrders();
    
        if ($orders) foreach($orders as $order)
        {
            try
            {
                $response = $helper_webservice->getShipmentForOrder($order);
                echo 'checking '.$order->getRealOrderId().'<br/>';
                Mage::log( 'checking:' .$order->getRealOrderId(), null, 'wics.log' );
                if (isset($response['success']) && $response['success'] == true && $response['content']['data'] != null )
                {
                    Mage::log( 'Updating order : '.$order->getRealOrderId(), null, 'wics.log' );
                     
                    $welppShipment = $response['content']['data'];
                    $itemQty = $order->getItemsCollection()->count();
                    $shipment = Mage::getModel('sales/service_order', $order)->prepareShipment($itemQty);
    
                    $shipment = new Mage_Sales_Model_Order_shipment_Api();
                    $shipmentId = $shipment->create($order->getRealOrderId());
                    $shipment_model = Mage::getModel('sales/order_shipment')->loadByIncrementId($shipmentId);
                     
                    $track_model = Mage::getModel('sales/order_shipment_track')
                    ->setShipment($shipment_model)
                    ->setData('title', $welppShipment['shippingOption']['combined'] )
                    ->setData('number', $welppShipment['shippingDetails']['trackAndTraceUrl'])
                    ->setData('carrier_code', 'custom')
                    ->setData('order_id', $shipment_model->getData('order_id'))
                    ->save();
    
                    $shipment_model->sendEmail();
                    $shipment_model->setEmailSent(true);
                    $shipment_model->save();
                }
            } catch (Exception $e) {
                echo "Could not add shipment to order.";
                Mage::log( 'Could not add shipment to order.', null, 'wics.log' );
            }
        } else {
            exit;
        }
    }

    /**
     * Real cron function.
     */
    private function _checkStock()
    {  	
    	Mage::log( 'Running checkStock...', null, 'wics.log' );
        	
       // Get the helpers
       $welppStockItems = Mage::getSingleton('Wics_Welpp_Helper_Webservice')->getAllStock();
                 
       foreach ($welppStockItems as $welppStockItem) 
       {
           $product = Mage::getModel('catalog/product')->loadByAttribute('sku', $welppStockItem['code'] );
         
           if ($product != false) 
           {
           		$stockItem = Mage::getModel('cataloginventory/stock_item')->loadByProduct( $product->getId() );
           	
           		if ( (int)$stockItem->getQty() != $welppStockItem['freeStock'] )
           		{           			
                	$stockItem->setQty( $welppStockItem['freeStock'] );
	                $stockItem->save();
	                
	                Mage::log( $welppStockItem['code'].' stock saved to: '.$welppStockItem['freeStock'], null, 'wics.log' );
		        }
		        if ($stockItem->getQty () > 0) {
		        
		        	$stockItem->setIsInStock ( 1 );
		        	$stockItem->save();
		        	Mage::log ( "(Cron) Stock has in stock " , null, 'wics.log' );
		        }
           }    
       }             
    }
    
    public function _itemExport(){
        Mage::log( 'Running _itemExport...', null, 'wics.log' );
        
        $collection = Mage::getResourceModel('catalog/product_collection');
        $welppItems = Mage::getSingleton('Wics_Welpp_Helper_Webservice')->getWelppItems();
        foreach($collection as $product) {
            $product = Mage::getModel('catalog/product')->load($product->getId());
             
            if($product->getSKU() != null){
                Mage::log( 'Item with sku:' .$product->getSKU() . ' must be exported', null, 'wics.log' );
                $welppItemExist = false;
                foreach($welppItems as $welppItem){
                     
                    if($welppItem->code == $product->getSKU()){
                        $welppItemExist = true;
                    }
                }
                 
                if($welppItemExist == false){
                     
                    $item["code"] = $product->getSKU();
                    $item["description"] = $product->getDescription();
                    $item["weight"] = $product->getWeight();
                    $item["massUnitName"] = "METRIC_MILLIGRAM";
                    $item["collitypeCode"] = "ST";
                    $item["ownerId"] = Mage::getStoreConfig('Wics_Welpp/general/customer_number', Mage::app()->getStore() );
                     
                    $message = Mage::getSingleton('Wics_Welpp_Helper_Webservice')->saveItem($item);
                     
                    Mage::log( 'Result: ' . $message, null, 'wics.log' );
                }
            }
        
        }
    }
    
    public function _getCarriers()
    {
        $carriers_config = Mage::getModel('shipping/config');
        $return = array();

        if ($carriers_config !== false) {
            $active_carriers = $carriers_config->getActiveCarriers();
            foreach ($active_carriers as $carrier) {
                $carrierCode = $carrier->getCarrierCode();
                $carrierName = Mage::getStoreConfig('carriers/' . $carrierCode . '/title');
                if (empty($carrierName)) {
                    $carrierName = Mage::getStoreConfig('customtrackers/' . $carrierCode . '/title');
                }

                $return[$carrierName] = $carrierCode;
            }
        }
        return $return;
    }

}