<?php
require_once (Mage::getModuleDir('controllers', 'Mage_Catalog') . DS . 'ProductController.php');

class Wics_Welpp_ProductController extends Mage_Catalog_ProductController
{

    /**
     * Product view action
     */
    public function viewAction()
    {
        // Get initial data from request
        $categoryId = (int) $this->getRequest()->getParam('category', false);
        $productId = (int) $this->getRequest()->getParam('id');
        $specifyOptions = $this->getRequest()->getParam('options');
        
        // Check the stock at WICS
        if (Mage::getStoreConfig('Wics_Welpp/stock_sync/enabled', Mage::app()->getStore()) === '1') {
           $this->checkStock($productId);
        }
        
        // Prepare helper and params
        $viewHelper = Mage::helper('catalog/product_view');
        
        $params = new Varien_Object();
        $params->setCategoryId($categoryId);
        $params->setSpecifyOptions($specifyOptions);
        
        // Render page
        try {
            $viewHelper->prepareAndRender($productId, $this, $params);
        } catch (Exception $e) {
            if ($e->getCode() == $viewHelper->ERR_NO_PRODUCT_LOADED) {
                if (isset($_GET['store']) && ! $this->getResponse()->isRedirect()) {
                    $this->_redirect('');
                } elseif (! $this->getResponse()->isRedirect()) {
                    $this->_forward('noRoute');
                }
            } else {
                Mage::logException($e);
                $this->_forward('noRoute');
            }
        }
    }
    
   
    private function checkStock($productId)
    {
        $stockItem = Mage::getModel('cataloginventory/stock_item')->loadByProduct($productId);
        $sku = Mage::getModel('catalog/product')->load($productId)->getSku();
        $stock = $helper_webservice = Mage::getSingleton('Wics_Welpp_Helper_Webservice')->getStock($sku);
       
        if (isset($stock['success']) && $stock['success'] == true) {
            if (isset($stock["data"])) {
                if ((int) $stockItem->getQty() != $stock["data"]["freeStock"]) {
                    $stockItem->setQty($stock["data"]["freeStock"]);
                    $stockItem->save();
                    
                    Mage::log($sku . ' stock saved to: ' . $stock["data"]["freeStock"], null, 'wics.log');
                    
                    if ((int) $stockItem->getQty() > 0) {
                        Mage::log("Stock live: ", null, 'wics.log');
                        $stockItem->setIsInStock(1);
                        $stockItem->save();
                    }
                }
            }
            
          
        }
    }
}

	
	
	
	